//
// OpenGL3.3 GLSL with GLEW - common.h
//
// $Id: common.h 43 2011-01-10 05:21:09Z bambooflow $
// $Rev: 43 $
// $Author: bambooflow $
//
//
#ifndef _COMMON_H_
#define _COMMON_H_

#include <iostream>
#include <fstream>

// for OpenGL4.x
#include <GL/glew.h>
#include <GL/glut.h> // freeglut

// OpenGL Mathematics Library
#include <glm/glm.hpp>
#include <glm/gtc/matrix_projection.hpp>
#include <glm/gtc/matrix_transform.hpp>
#include <glm/gtx/transform2.hpp>
#include <glm/gtc/type_ptr.hpp>

#include "model.h"
#include "basic_shape.h"
#include "load_shader.h"
#include "load_obj.h"


#if DEBUG
#define glError() { \
  GLenum err = glGetError(); \
  while (err != GL_NO_ERROR) { \
    switch (err) {\
    case GL_INVALID_ENUM:      std::cerr << "Error : GL_INVALID_ENUM\n";      break; \
    case GL_INVALID_VALUE:     std::cerr << "Error : GL_INVALID_VALUE\n";     break; \
    case GL_INVALID_OPERATION: std::cerr << "Error : GL_INVALID_OPERATION\n"; break; \
    case GL_STACK_OVERFLOW:    std::cerr << "Error : GL_STACK_OVERFLOW\n";    break; \
    case GL_STACK_UNDERFLOW:   std::cerr << "Error : GL_STACK_UNDERFLOW\n";   break; \
    case GL_OUT_OF_MEMORY:     std::cerr << "Error : GL_OUT_OF_MEMORY\n";     break; \
    case GL_TABLE_TOO_LARGE:   std::cerr << "Error : GL_TABLE_TOO_LARGE\n";   break; \
    default: std::cerr << "Error : no = " << err << "\n"; \
    } \
    std::cerr << "File:" << __FILE__ << ", Line:" << __LINE__ << "\n"; \
    err = glGetError(); \
  } \
}
#else
#define glError() 
#endif



#endif // _COMMON_H_
