#include "model.h"

#include <cstdlib>
#include <cstring>


Model* createShape(
    Vertex*    vertices,
    glm::uint  numVertices,
    glm::uint* indices,
    glm::uint  numIndices
)
{
  Model* shape = new Model();
  if (!shape) { return NULL; }

  shape->numVertices = numVertices;
  shape->numIndices = numIndices;

  shape->vertices = new Vertex[numVertices];
  if (!shape->vertices) { return NULL; }
  memcpy( shape->vertices, vertices, numVertices*sizeof(Vertex) );

  shape->indices = new uint[numIndices];
  if (!shape->indices) { return NULL; }
  memcpy( shape->indices, indices, numIndices*sizeof(glm::uint) );

  return shape;
}


void addMaterial(Model* shape, const Material& material)
{
  shape->materials.push_back( material );
}


void destroyShape( Model* shape )
{
  if (!shape) { return; }

  if (shape->vertices) {
    delete [] shape->vertices;
    shape->vertices = NULL;
  }
  if (shape->indices) {
    delete [] shape->indices;
    shape->indices = NULL;
  }

  delete [] shape;
  shape = NULL;
}


